# app.py
from flask import Flask, render_template, request,\
    redirect

from datetime import datetime

app = Flask(__name__)

@app.route(
    rule="/",
    methods=["GET"]
)
def mostrar_form_de_procurar():
    return render_template(
        "gs.html"
    )
# def mostrar_form_de_procurar

NOME_DA_BD = "DB.TSV"
def memorizar_procura(
    p_qs:str # exemplo "https://www.google.com/search?q=pipocas&start=1&num=50"
):
    # solução de DB é ficheiros TSV
    # fw "file write"
    try:
        fw = \
            open(NOME_DA_BD, 'at') # append text
        if (fw): # parentesis são opcionais
            quando = datetime.now()
            procura = p_qs
            registo_tsv:str =\
                f"{quando}\t{procura}\n"

            quantos_bytes_foram_escritos =\
                fw.write(registo_tsv)

            fw.close()
            return True
        # if (fw)
    except Exception as e:
        print(str(e))
        return False
    # try-except
# def memorizar_procura

@app.route("/qs/<path:qs>")
def interceptar_qs(qs):
    real_qs = request.full_path[4:]
    # return f"{real_qs}"

    memorizar_procura(real_qs)

    return redirect(real_qs)
# def interceptar_qs

@app.route(
    rule="/all",
    methods=["GET", "POST"]
)
def solucao_para_mostrar_todas_procuras():
    resultados:list = list()
    # resultados = []

    try:
        fr = open(
            NOME_DA_BD,
            'rt'
        )
        if(fr):
            conteudo = fr.read()
            registos = conteudo.split("\n")
            for r in registos:
                b_linha_vazia:bool =\
                    r.strip()==""
                if(not b_linha_vazia):
                    partes = r.split("\t")
                    quando = partes[0]
                    procura = partes[1]

                    d:dict = dict()
                    d['quando']=quando
                    d['procura']=procura
                    resultados.append(d)
                # if
            # for
            # lista de dicionários
            # JSON JavaScript Object Notation
            # info: os dicionários Python são estruturas JSON
            # return resultados # JSON

            # controlar nós o HTML output (em vez de raw JSON)
            minha_lista = "<ol>"

            # construir os list items
            for r in resultados:
                q = f"<mark>{r['quando']}</mark>"
                href = r['procura']
                pv = f"<a href='{href}'>{href}</a>"
                li:str=f"<li>{q}<br>{pv}</li>"
                minha_lista+=li
            # for

            minha_lista +="</ol>"
            return minha_lista
        # if
    # try
    except Exception as e:
        return str(e)
# def solucao_para_mostrar_todas_procuras

app.run(
    debug=True,
    port=5006
)