// gs.js
window.onload = boot

const FRASE_VAZIA = ""
const FRASE_NO_FILTER =
    "Resultados NÃO serão filtrados"

const NO_SAFETY = "off"
const ANY_RECENCY = "any"

const ID_Q = "idQ",
        ID_BTN_SEARCH = "idBtnSearch",
        ID_CHECK_ORDER_IS_RELEVANT = "idCheckOrderIsRelevant",
        ID_STARTING_RANK = "idStartingRank",
        ID_HOW_MANY_RESULTS = "idHowManyResults",
        ID_TEXT_FILTER = "idTextFilter",
        ID_SELECT_FILTER = "idSelectFilter",
        ID_SPAN_FILTER_FB = "idSpanFilterFeedback",
        ID_SELECT_SAFETY = "idSelectSafety",
        ID_SELECT_RECENCY = "idSelectRecency"

const URL_BASE = "https://www.google.com/search?"

var oQ, oBtnSearch, oCheckOrderIsRelevant,
    oStartingRank,
    oHowManyResults,
    oTextFilter, oSelectFilter, oSpanFilterFB,
    oSelectSafety, oSelectRecency

function boot(){
    // associações / bindings
    oQ = id(ID_Q)
    oBtnSearch = id(ID_BTN_SEARCH)
    oCheckOrderIsRelevant = id(ID_CHECK_ORDER_IS_RELEVANT)
    oStartingRank = id(ID_STARTING_RANK)
    oHowManyResults = id(ID_HOW_MANY_RESULTS)
    oTextFilter = id(ID_TEXT_FILTER)
    oSelectFilter = id(ID_SELECT_FILTER)
    oSpanFilterFB = id(ID_SPAN_FILTER_FB)
    oSelectSafety = id(ID_SELECT_SAFETY)
    oSelectRecency = id(ID_SELECT_RECENCY)

    // controlo de qualidade
    // TODO ++++
    var aRelevantes = [
        oQ, oBtnSearch, oCheckOrderIsRelevant,
        oStartingRank, oHowManyResults, oTextFilter,
        oSelectFilter, oSpanFilterFB, oSelectSafety,
        oSelectRecency
    ]

    // use only in dev-time
    // comment after that
    var b_ok = quality_control(aRelevantes)
    if(!b_ok){
        window.alert("Critical error. System will NOT work.")
        return
    }
    else{
        // nada
        //window.alert("QC passed")
    }

    // comportamentos / behavior setting
    oBtnSearch.onclick = go_search
    /*
    input - está a acontecer entrada de dados
    change - houve mudança na entrada de dados
     */
    oTextFilter.oninput = filter_fb // dar feedback do filtro ativo
    // oSelectFilter.oninput = filter_fb
    oSelectFilter.onchange = filter_fb

    oTextFilter.oninput = oSelectFilter.onchange = filter_fb
}//boot

const DONT_FILTER = "all"

function filter_fb(){
    // colisão de identificadores
    // vale, pelo "princípio da localidade",
    // o identificador de contexto mais próximo
    // (a função)
    /*
    const FRASE_VAZIA = ""
    const FRASE_NO_FILTER =
        "Resultados NÃO serão filtrados"
     */
    var fb = ""

    var filter_text = oTextFilter.value.trim()
    var filter_select = oSelectFilter.value.trim()

    var b_no_text_filter =
        filter_text === FRASE_VAZIA
    var b_no_select_filter =
        oSelectFilter.value==DONT_FILTER // comparar com "all"

    var b_no_filter = b_no_text_filter
        &&
        b_no_select_filter

    if(b_no_filter){
        oSpanFilterFB.innerHTML = FRASE_NO_FILTER
        oSpanFilterFB.innerHTML = fb
        return ""
    }
    else{
        // havendo algum tipo de filtro
        // há que desambiguar
        // esclarecer que tipo de filtragem vai
        // realmente acontecer

        if(!b_no_select_filter){
            fb = `Resultados serão filtrados por ${filter_select}`
            oSpanFilterFB.innerHTML = fb
            return filter_select
        }
        else{
            fb = `Resultados serão filtrados por ${filter_text}`
            oSpanFilterFB.innerHTML = fb
            return filter_text
        }
    }//else
}//filter_fb

function build_query_string(){
    var search_expression =
        encodeURIComponent(
            oQ.value.trim() // elimina espaços em branco à esquerda *e* à direita
        )

    var b_order_is_relevant =
        oCheckOrderIsRelevant.checked

    var i_starting_rank = Number(
        oStartingRank.value
    )

    var qs = b_order_is_relevant ?
        URL_BASE+"as_epq="+search_expression
        :
        URL_BASE+"q="+search_expression

    qs+="&start=" + i_starting_rank.toString()

    var numOfResults = Number(oHowManyResults.value)
    qs+="&num=" + numOfResults

    var filter_to_apply = filter_fb()
    filter = filter_to_apply=="" ?
        ""
        :
        encodeURIComponent(filter_to_apply)

    if(filter!="")
        qs+="&as_sitesearch="+filter

    // safety
    var v_safety = oSelectSafety.value.trim()
    var b_safety = v_safety!==NO_SAFETY
    if(b_safety)
        qs+="&safety="+v_safety

    // recency
    var v_recency = oSelectRecency.value.trim()
    var b_recency = v_recency!==ANY_RECENCY
    if(b_recency)
        qs+="&as_qdr="+v_recency

    // return undefined
    return qs
}//build_query_string

function go_search(){
    var qs = build_query_string()

    // document.location.href = qs // direto para a Google
    document.location.href = `/qs/${qs}` // direto para a Web App
}//go_search